#include "precomp.h"
#include <MAPIX.H>
#include <MAPIUTIL.H>
#include <MAPIFORM.H>
#include <EXCHEXT.H>

// THESE I FOUND USEFULL, BUT DON'T HAVE REAL DESCRIPTIONS
#define PR_INTERNET_MESSAGE_ID 0x1035001e
#define PR_INTERNET_REFERENCES 0x1039001e
#define PR_INTERNET_PROP1 0x1042001e
#define PR_INTERNET_PROP2 0x1043001e
#define PR_INTERNET_PROP3 0x1044001e
#define PR_INTERNET_PROP4 0x1045001e
#define PR_INTERNET_PROP5 0x1046001e
#define PR_INTERNET_SENDER 0x8070001e
#define PR_INTERNET_RECEIVERS 0x8071001e
#define PR_INTERNET_SENDER_TYPE 0x8080001e
#define PR_INTERNET_PROP6 0x8103001e
#define PR_HTML_BODY 0x1013001e

/* Written by Gerson Kurz (gerson.kurz@t-online.de). Freeware. Enjoy. */

typedef struct
{
    DWORD dwTag;
    LPCSTR lpszString;
} MAPI_TAG_DESCRIPTION;

// THIS SOURCE SHOWS WHY I LOVE MACROS

#define MTD(__X) { __X, #__X }

static MAPI_TAG_DESCRIPTION descriptions[] = {

MTD(PR_INTERNET_MESSAGE_ID                      ),
MTD(PR_INTERNET_REFERENCES                      ),
MTD(PR_INTERNET_PROP1                           ),
MTD(PR_INTERNET_PROP2                           ),
MTD(PR_INTERNET_PROP3                           ),
MTD(PR_INTERNET_PROP4                           ),
MTD(PR_INTERNET_PROP5                           ),
MTD(PR_INTERNET_SENDER                          ),
MTD(PR_INTERNET_RECEIVERS                       ),
MTD(PR_INTERNET_SENDER_TYPE                     ),
MTD(PR_INTERNET_PROP6                           ),
MTD(PR_HTML_BODY                                ),

MTD(PR_ACKNOWLEDGEMENT_MODE                     ),
MTD(PR_ALTERNATE_RECIPIENT_ALLOWED              ),
MTD(PR_AUTHORIZING_USERS                        ),
MTD(PR_AUTO_FORWARD_COMMENT                     ),
MTD(PR_AUTO_FORWARD_COMMENT_W                   ),
MTD(PR_AUTO_FORWARD_COMMENT_A                   ),
MTD(PR_AUTO_FORWARDED                           ),
MTD(PR_CONTENT_CONFIDENTIALITY_ALGORITHM_ID     ),
MTD(PR_CONTENT_CORRELATOR                       ),
MTD(PR_CONTENT_IDENTIFIER                       ),
MTD(PR_CONTENT_IDENTIFIER_W                     ),
MTD(PR_CONTENT_IDENTIFIER_A                     ),
MTD(PR_CONTENT_LENGTH                           ),
MTD(PR_CONTENT_RETURN_REQUESTED                 ),
MTD(PR_CONVERSATION_KEY                         ),
MTD(PR_CONVERSION_EITS                          ),
MTD(PR_CONVERSION_WITH_LOSS_PROHIBITED          ),
MTD(PR_CONVERTED_EITS                           ),
MTD(PR_DEFERRED_DELIVERY_TIME                   ),
MTD(PR_DELIVER_TIME                             ),
MTD(PR_DISCARD_REASON                           ),
MTD(PR_DISCLOSURE_OF_RECIPIENTS                 ),
MTD(PR_DL_EXPANSION_HISTORY                     ),
MTD(PR_DL_EXPANSION_PROHIBITED                  ),
MTD(PR_EXPIRY_TIME                              ),
MTD(PR_IMPLICIT_CONVERSION_PROHIBITED           ),
MTD(PR_IMPORTANCE                               ),
MTD(PR_IPM_ID                                   ),
MTD(PR_LATEST_DELIVERY_TIME                     ),
MTD(PR_MESSAGE_CLASS                            ),
MTD(PR_MESSAGE_CLASS_W                          ),
MTD(PR_MESSAGE_CLASS_A                          ),
MTD(PR_MESSAGE_DELIVERY_ID                      ),
MTD(PR_MESSAGE_SECURITY_LABEL                   ),
MTD(PR_OBSOLETED_IPMS                           ),
MTD(PR_ORIGINALLY_INTENDED_RECIPIENT_NAME       ),
MTD(PR_ORIGINAL_EITS                            ),
MTD(PR_ORIGINATOR_CERTIFICATE                   ),
MTD(PR_ORIGINATOR_DELIVERY_REPORT_REQUESTED     ),
MTD(PR_ORIGINATOR_RETURN_ADDRESS                ),
MTD(PR_PARENT_KEY                               ),
MTD(PR_PRIORITY                                 ),
MTD(PR_ORIGIN_CHECK                             ),
MTD(PR_PROOF_OF_SUBMISSION_REQUESTED            ),
MTD(PR_READ_RECEIPT_REQUESTED                   ),
MTD(PR_RECEIPT_TIME                             ),
MTD(PR_RECIPIENT_REASSIGNMENT_PROHIBITED        ),
MTD(PR_REDIRECTION_HISTORY                      ),
MTD(PR_RELATED_IPMS                             ),
MTD(PR_ORIGINAL_SENSITIVITY                     ),
MTD(PR_LANGUAGES                                ),
MTD(PR_LANGUAGES_W                              ),
MTD(PR_LANGUAGES_A                              ),
MTD(PR_REPLY_TIME                               ),
MTD(PR_REPORT_TAG                               ),
MTD(PR_REPORT_TIME                              ),
MTD(PR_RETURNED_IPM                             ),
MTD(PR_SECURITY                                 ),
MTD(PR_INCOMPLETE_COPY                          ),
MTD(PR_SENSITIVITY                              ),
MTD(PR_SUBJECT                                  ),
MTD(PR_SUBJECT_W                                ),
MTD(PR_SUBJECT_A                                ),
MTD(PR_SUBJECT_IPM                              ),
MTD(PR_CLIENT_SUBMIT_TIME                       ),
MTD(PR_REPORT_NAME                              ),
MTD(PR_REPORT_NAME_W                            ),
MTD(PR_REPORT_NAME_A                            ),
MTD(PR_SENT_REPRESENTING_SEARCH_KEY             ),
MTD(PR_X400_CONTENT_TYPE                        ),
MTD(PR_SUBJECT_PREFIX                           ),
MTD(PR_SUBJECT_PREFIX_W                         ),
MTD(PR_SUBJECT_PREFIX_A                         ),
MTD(PR_NON_RECEIPT_REASON                       ),
MTD(PR_RECEIVED_BY_ENTRYID                      ),
MTD(PR_RECEIVED_BY_NAME                         ),
MTD(PR_RECEIVED_BY_NAME_W                       ),
MTD(PR_RECEIVED_BY_NAME_A                       ),
MTD(PR_SENT_REPRESENTING_ENTRYID                ),
MTD(PR_SENT_REPRESENTING_NAME                   ),
MTD(PR_SENT_REPRESENTING_NAME_W                 ),
MTD(PR_SENT_REPRESENTING_NAME_A                 ),
MTD(PR_RCVD_REPRESENTING_ENTRYID                ),
MTD(PR_RCVD_REPRESENTING_NAME                   ),
MTD(PR_RCVD_REPRESENTING_NAME_W                 ),
MTD(PR_RCVD_REPRESENTING_NAME_A                 ),
MTD(PR_REPORT_ENTRYID                           ),
MTD(PR_READ_RECEIPT_ENTRYID                     ),
MTD(PR_MESSAGE_SUBMISSION_ID                    ),
MTD(PR_PROVIDER_SUBMIT_TIME                     ),
MTD(PR_ORIGINAL_SUBJECT                         ),
MTD(PR_ORIGINAL_SUBJECT_W                       ),
MTD(PR_ORIGINAL_SUBJECT_A                       ),
MTD(PR_DISC_VAL                                 ),
MTD(PR_ORIG_MESSAGE_CLASS                       ),
MTD(PR_ORIG_MESSAGE_CLASS_W                     ),
MTD(PR_ORIG_MESSAGE_CLASS_A                     ),
MTD(PR_ORIGINAL_AUTHOR_ENTRYID                  ),
MTD(PR_ORIGINAL_AUTHOR_NAME                     ),
MTD(PR_ORIGINAL_AUTHOR_NAME_W                   ),
MTD(PR_ORIGINAL_AUTHOR_NAME_A                   ),
MTD(PR_ORIGINAL_SUBMIT_TIME                     ),
MTD(PR_REPLY_RECIPIENT_ENTRIES                  ),
MTD(PR_REPLY_RECIPIENT_NAMES                    ),
MTD(PR_REPLY_RECIPIENT_NAMES_W                  ),
MTD(PR_REPLY_RECIPIENT_NAMES_A                  ),
MTD(PR_RECEIVED_BY_SEARCH_KEY                   ),
MTD(PR_RCVD_REPRESENTING_SEARCH_KEY             ),
MTD(PR_READ_RECEIPT_SEARCH_KEY                  ),
MTD(PR_REPORT_SEARCH_KEY                        ),
MTD(PR_ORIGINAL_DELIVERY_TIME                   ),
MTD(PR_ORIGINAL_AUTHOR_SEARCH_KEY               ),
MTD(PR_MESSAGE_TO_ME                            ),
MTD(PR_MESSAGE_CC_ME                            ),
MTD(PR_MESSAGE_RECIP_ME                         ),
MTD(PR_ORIGINAL_SENDER_NAME                     ),
MTD(PR_ORIGINAL_SENDER_NAME_W                   ),
MTD(PR_ORIGINAL_SENDER_NAME_A                   ),
MTD(PR_ORIGINAL_SENDER_ENTRYID                  ),
MTD(PR_ORIGINAL_SENDER_SEARCH_KEY               ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_NAME          ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_NAME_W        ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_NAME_A        ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_ENTRYID       ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_SEARCH_KEY    ),
MTD(PR_START_DATE                               ),
MTD(PR_END_DATE                                 ),
MTD(PR_OWNER_APPT_ID                            ),
MTD(PR_RESPONSE_REQUESTED                       ),
MTD(PR_SENT_REPRESENTING_ADDRTYPE               ),
MTD(PR_SENT_REPRESENTING_ADDRTYPE_W             ),
MTD(PR_SENT_REPRESENTING_ADDRTYPE_A             ),
MTD(PR_SENT_REPRESENTING_EMAIL_ADDRESS          ),
MTD(PR_SENT_REPRESENTING_EMAIL_ADDRESS_W        ),
MTD(PR_SENT_REPRESENTING_EMAIL_ADDRESS_A        ),
MTD(PR_ORIGINAL_SENDER_ADDRTYPE                 ),
MTD(PR_ORIGINAL_SENDER_ADDRTYPE_W               ),
MTD(PR_ORIGINAL_SENDER_ADDRTYPE_A               ),
MTD(PR_ORIGINAL_SENDER_EMAIL_ADDRESS            ),
MTD(PR_ORIGINAL_SENDER_EMAIL_ADDRESS_W          ),
MTD(PR_ORIGINAL_SENDER_EMAIL_ADDRESS_A          ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE      ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE_W    ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE_A    ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS_W ),
MTD(PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS_A ),
MTD(PR_CONVERSATION_TOPIC                       ),
MTD(PR_CONVERSATION_TOPIC_W                     ),
MTD(PR_CONVERSATION_TOPIC_A                     ),
MTD(PR_CONVERSATION_INDEX                       ),
MTD(PR_ORIGINAL_DISPLAY_BCC                     ),
MTD(PR_ORIGINAL_DISPLAY_BCC_W                   ),
MTD(PR_ORIGINAL_DISPLAY_BCC_A                   ),
MTD(PR_ORIGINAL_DISPLAY_CC                      ),
MTD(PR_ORIGINAL_DISPLAY_CC_W                    ),
MTD(PR_ORIGINAL_DISPLAY_CC_A                    ),
MTD(PR_ORIGINAL_DISPLAY_TO                      ),
MTD(PR_ORIGINAL_DISPLAY_TO_W                    ),
MTD(PR_ORIGINAL_DISPLAY_TO_A                    ),
MTD(PR_RECEIVED_BY_ADDRTYPE                     ),
MTD(PR_RECEIVED_BY_ADDRTYPE_W                   ),
MTD(PR_RECEIVED_BY_ADDRTYPE_A                   ),
MTD(PR_RECEIVED_BY_EMAIL_ADDRESS                ),
MTD(PR_RECEIVED_BY_EMAIL_ADDRESS_W              ),
MTD(PR_RECEIVED_BY_EMAIL_ADDRESS_A              ),
MTD(PR_RCVD_REPRESENTING_ADDRTYPE               ),
MTD(PR_RCVD_REPRESENTING_ADDRTYPE_W             ),
MTD(PR_RCVD_REPRESENTING_ADDRTYPE_A             ),
MTD(PR_RCVD_REPRESENTING_EMAIL_ADDRESS          ),
MTD(PR_RCVD_REPRESENTING_EMAIL_ADDRESS_W        ),
MTD(PR_RCVD_REPRESENTING_EMAIL_ADDRESS_A        ),
MTD(PR_ORIGINAL_AUTHOR_ADDRTYPE                 ),
MTD(PR_ORIGINAL_AUTHOR_ADDRTYPE_W               ),
MTD(PR_ORIGINAL_AUTHOR_ADDRTYPE_A               ),
MTD(PR_ORIGINAL_AUTHOR_EMAIL_ADDRESS            ),
MTD(PR_ORIGINAL_AUTHOR_EMAIL_ADDRESS_W          ),
MTD(PR_ORIGINAL_AUTHOR_EMAIL_ADDRESS_A          ),
MTD(PR_ORIGINALLY_INTENDED_RECIP_ADDRTYPE       ),
MTD(PR_ORIGINALLY_INTENDED_RECIP_ADDRTYPE_W     ),
MTD(PR_ORIGINALLY_INTENDED_RECIP_ADDRTYPE_A     ),
MTD(PR_ORIGINALLY_INTENDED_RECIP_EMAIL_ADDRESS  ),
MTD(PR_ORIGINALLY_INTENDED_RECIP_EMAIL_ADDRESS_W ),
MTD(PR_ORIGINALLY_INTENDED_RECIP_EMAIL_ADDRESS_A ),
MTD(PR_TRANSPORT_MESSAGE_HEADERS                ),
MTD(PR_TRANSPORT_MESSAGE_HEADERS_W              ),
MTD(PR_TRANSPORT_MESSAGE_HEADERS_A              ),
MTD(PR_DELEGATION                               ),
MTD(PR_TNEF_CORRELATION_KEY                     ),
MTD(PR_BODY                                     ),
MTD(PR_BODY_W                                   ),
MTD(PR_BODY_A                                   ),
MTD(PR_REPORT_TEXT                              ),
MTD(PR_REPORT_TEXT_W                            ),
MTD(PR_REPORT_TEXT_A                            ),
MTD(PR_ORIGINATOR_AND_DL_EXPANSION_HISTORY      ),
MTD(PR_REPORTING_DL_NAME                        ),
MTD(PR_REPORTING_MTA_CERTIFICATE                ),
MTD(PR_RTF_SYNC_BODY_CRC                        ),
MTD(PR_RTF_SYNC_BODY_COUNT                      ),
MTD(PR_RTF_SYNC_BODY_TAG                        ),
MTD(PR_RTF_SYNC_BODY_TAG_W                      ),
MTD(PR_RTF_SYNC_BODY_TAG_A                      ),
MTD(PR_RTF_COMPRESSED                           ),
MTD(PR_RTF_SYNC_PREFIX_COUNT                    ),
MTD(PR_RTF_SYNC_TRAILING_COUNT                  ),
MTD(PR_ORIGINALLY_INTENDED_RECIP_ENTRYID        ),
MTD(PR_CONTENT_INTEGRITY_CHECK                  ),
MTD(PR_EXPLICIT_CONVERSION                      ),
MTD(PR_IPM_RETURN_REQUESTED                     ),
MTD(PR_MESSAGE_TOKEN                            ),
MTD(PR_NDR_REASON_CODE                          ),
MTD(PR_NDR_DIAG_CODE                            ),
MTD(PR_NON_RECEIPT_NOTIFICATION_REQUESTED       ),
MTD(PR_DELIVERY_POINT                           ),
MTD(PR_ORIGINATOR_NON_DELIVERY_REPORT_REQUESTED ),
MTD(PR_ORIGINATOR_REQUESTED_ALTERNATE_RECIPIENT ),
MTD(PR_PHYSICAL_DELIVERY_BUREAU_FAX_DELIVERY    ),
MTD(PR_PHYSICAL_DELIVERY_MODE                   ),
MTD(PR_PHYSICAL_DELIVERY_REPORT_REQUEST         ),
MTD(PR_PHYSICAL_FORWARDING_ADDRESS              ),
MTD(PR_PHYSICAL_FORWARDING_ADDRESS_REQUESTED    ),
MTD(PR_PHYSICAL_FORWARDING_PROHIBITED           ),
MTD(PR_PHYSICAL_RENDITION_ATTRIBUTES            ),
MTD(PR_PROOF_OF_DELIVERY                        ),
MTD(PR_PROOF_OF_DELIVERY_REQUESTED              ),
MTD(PR_RECIPIENT_CERTIFICATE                    ),
MTD(PR_RECIPIENT_NUMBER_FOR_ADVICE              ),
MTD(PR_RECIPIENT_NUMBER_FOR_ADVICE_W            ),
MTD(PR_RECIPIENT_NUMBER_FOR_ADVICE_A            ),
MTD(PR_RECIPIENT_TYPE                           ),
MTD(PR_REGISTERED_MAIL_TYPE                     ),
MTD(PR_REPLY_REQUESTED                          ),
MTD(PR_REQUESTED_DELIVERY_METHOD                ),
MTD(PR_SENDER_ENTRYID                           ),
MTD(PR_SENDER_NAME                              ),
MTD(PR_SENDER_NAME_W                            ),
MTD(PR_SENDER_NAME_A                            ),
MTD(PR_SUPPLEMENTARY_INFO                       ),
MTD(PR_SUPPLEMENTARY_INFO_W                     ),
MTD(PR_SUPPLEMENTARY_INFO_A                     ),
MTD(PR_TYPE_OF_MTS_USER                         ),
MTD(PR_SENDER_SEARCH_KEY                        ),
MTD(PR_SENDER_ADDRTYPE                          ),
MTD(PR_SENDER_ADDRTYPE_W                        ),
MTD(PR_SENDER_ADDRTYPE_A                        ),
MTD(PR_SENDER_EMAIL_ADDRESS                     ),
MTD(PR_SENDER_EMAIL_ADDRESS_W                   ),
MTD(PR_SENDER_EMAIL_ADDRESS_A                   ),
MTD(PR_CURRENT_VERSION                          ),
MTD(PR_DELETE_AFTER_SUBMIT                      ),
MTD(PR_DISPLAY_BCC                              ),
MTD(PR_DISPLAY_BCC_W                            ),
MTD(PR_DISPLAY_BCC_A                            ),
MTD(PR_DISPLAY_CC                               ),
MTD(PR_DISPLAY_CC_W                             ),
MTD(PR_DISPLAY_CC_A                             ),
MTD(PR_DISPLAY_TO                               ),
MTD(PR_DISPLAY_TO_W                             ),
MTD(PR_DISPLAY_TO_A                             ),
MTD(PR_PARENT_DISPLAY                           ),
MTD(PR_PARENT_DISPLAY_W                         ),
MTD(PR_PARENT_DISPLAY_A                         ),
MTD(PR_MESSAGE_DELIVERY_TIME                    ),
MTD(PR_MESSAGE_FLAGS                            ),
MTD(PR_MESSAGE_SIZE                             ),
MTD(PR_PARENT_ENTRYID                           ),
MTD(PR_SENTMAIL_ENTRYID                         ),
MTD(PR_CORRELATE                                ),
MTD(PR_CORRELATE_MTSID                          ),
MTD(PR_DISCRETE_VALUES                          ),
MTD(PR_RESPONSIBILITY                           ),
MTD(PR_SPOOLER_STATUS                           ),
MTD(PR_TRANSPORT_STATUS                         ),
MTD(PR_MESSAGE_RECIPIENTS                       ),
MTD(PR_MESSAGE_ATTACHMENTS                      ),
MTD(PR_SUBMIT_FLAGS                             ),
MTD(PR_RECIPIENT_STATUS                         ),
MTD(PR_TRANSPORT_KEY                            ),
MTD(PR_MSG_STATUS                               ),
MTD(PR_MESSAGE_DOWNLOAD_TIME                    ),
MTD(PR_CREATION_VERSION                         ),
MTD(PR_MODIFY_VERSION                           ),
MTD(PR_HASATTACH                                ),
MTD(PR_BODY_CRC                                 ),
MTD(PR_NORMALIZED_SUBJECT                       ),
MTD(PR_NORMALIZED_SUBJECT_W                     ),
MTD(PR_NORMALIZED_SUBJECT_A                     ),
MTD(PR_RTF_IN_SYNC                              ),
MTD(PR_ATTACH_SIZE                              ),
MTD(PR_ATTACH_NUM                               ),
MTD(PR_PREPROCESS                               ),
MTD(PR_ORIGINATING_MTA_CERTIFICATE              ),
MTD(PR_PROOF_OF_SUBMISSION                      ),
MTD(PR_ENTRYID                                  ),
MTD(PR_OBJECT_TYPE                              ),
MTD(PR_ICON                                     ),
MTD(PR_MINI_ICON                                ),
MTD(PR_STORE_ENTRYID                            ),
MTD(PR_STORE_RECORD_KEY                         ),
MTD(PR_RECORD_KEY                               ),
MTD(PR_MAPPING_SIGNATURE                        ),
MTD(PR_ACCESS_LEVEL                             ),
MTD(PR_INSTANCE_KEY                             ),
MTD(PR_ROW_TYPE                                 ),
MTD(PR_ACCESS                                   ),
MTD(PR_ROWID                                    ),
MTD(PR_DISPLAY_NAME                             ),
MTD(PR_DISPLAY_NAME_W                           ),
MTD(PR_DISPLAY_NAME_A                           ),
MTD(PR_ADDRTYPE                                 ),
MTD(PR_ADDRTYPE_W                               ),
MTD(PR_ADDRTYPE_A                               ),
MTD(PR_EMAIL_ADDRESS                            ),
MTD(PR_EMAIL_ADDRESS_W                          ),
MTD(PR_EMAIL_ADDRESS_A                          ),
MTD(PR_COMMENT                                  ),
MTD(PR_COMMENT_W                                ),
MTD(PR_COMMENT_A                                ),
MTD(PR_DEPTH                                    ),
MTD(PR_PROVIDER_DISPLAY                         ),
MTD(PR_PROVIDER_DISPLAY_W                       ),
MTD(PR_PROVIDER_DISPLAY_A                       ),
MTD(PR_CREATION_TIME                            ),
MTD(PR_LAST_MODIFICATION_TIME                   ),
MTD(PR_RESOURCE_FLAGS                           ),
MTD(PR_PROVIDER_DLL_NAME                        ),
MTD(PR_PROVIDER_DLL_NAME_W                      ),
MTD(PR_PROVIDER_DLL_NAME_A                      ),
MTD(PR_SEARCH_KEY                               ),
MTD(PR_PROVIDER_UID                             ),
MTD(PR_PROVIDER_ORDINAL                         ),
MTD(PR_FORM_VERSION                             ),
MTD(PR_FORM_VERSION_W                           ),
MTD(PR_FORM_VERSION_A                           ),
MTD(PR_FORM_CLSID                               ),
MTD(PR_FORM_CONTACT_NAME                        ),
MTD(PR_FORM_CONTACT_NAME_W                      ),
MTD(PR_FORM_CONTACT_NAME_A                      ),
MTD(PR_FORM_CATEGORY                            ),
MTD(PR_FORM_CATEGORY_W                          ),
MTD(PR_FORM_CATEGORY_A                          ),
MTD(PR_FORM_CATEGORY_SUB                        ),
MTD(PR_FORM_CATEGORY_SUB_W                      ),
MTD(PR_FORM_CATEGORY_SUB_A                      ),
MTD(PR_FORM_HOST_MAP                            ),
MTD(PR_FORM_HIDDEN                              ),
MTD(PR_FORM_DESIGNER_NAME                       ),
MTD(PR_FORM_DESIGNER_NAME_W                     ),
MTD(PR_FORM_DESIGNER_NAME_A                     ),
MTD(PR_FORM_DESIGNER_GUID                       ),
MTD(PR_FORM_MESSAGE_BEHAVIOR                    ),
MTD(PR_DEFAULT_STORE                            ),
MTD(PR_STORE_SUPPORT_MASK                       ),
MTD(PR_STORE_STATE                              ),
MTD(PR_IPM_SUBTREE_SEARCH_KEY                   ),
MTD(PR_IPM_OUTBOX_SEARCH_KEY                    ),
MTD(PR_IPM_WASTEBASKET_SEARCH_KEY               ),
MTD(PR_IPM_SENTMAIL_SEARCH_KEY                  ),
MTD(PR_MDB_PROVIDER                             ),
MTD(PR_RECEIVE_FOLDER_SETTINGS                  ),
MTD(PR_VALID_FOLDER_MASK                        ),
MTD(PR_IPM_SUBTREE_ENTRYID                      ),
MTD(PR_IPM_OUTBOX_ENTRYID                       ),
MTD(PR_IPM_WASTEBASKET_ENTRYID                  ),
MTD(PR_IPM_SENTMAIL_ENTRYID                     ),
MTD(PR_VIEWS_ENTRYID                            ),
MTD(PR_COMMON_VIEWS_ENTRYID                     ),
MTD(PR_FINDER_ENTRYID                           ),
MTD(PR_CONTAINER_FLAGS                          ),
MTD(PR_FOLDER_TYPE                              ),
MTD(PR_CONTENT_COUNT                            ),
MTD(PR_CONTENT_UNREAD                           ),
MTD(PR_CREATE_TEMPLATES                         ),
MTD(PR_DETAILS_TABLE                            ),
MTD(PR_SEARCH                                   ),
MTD(PR_SELECTABLE                               ),
MTD(PR_SUBFOLDERS                               ),
MTD(PR_STATUS                                   ),
MTD(PR_ANR                                      ),
MTD(PR_ANR_W                                    ),
MTD(PR_ANR_A                                    ),
MTD(PR_CONTENTS_SORT_ORDER                      ),
MTD(PR_CONTAINER_HIERARCHY                      ),
MTD(PR_CONTAINER_CONTENTS                       ),
MTD(PR_FOLDER_ASSOCIATED_CONTENTS               ),
MTD(PR_DEF_CREATE_DL                            ),
MTD(PR_DEF_CREATE_MAILUSER                      ),
MTD(PR_CONTAINER_CLASS                          ),
MTD(PR_CONTAINER_CLASS_W                        ),
MTD(PR_CONTAINER_CLASS_A                        ),
MTD(PR_CONTAINER_MODIFY_VERSION                 ),
MTD(PR_AB_PROVIDER_ID                           ),
MTD(PR_DEFAULT_VIEW_ENTRYID                     ),
MTD(PR_ASSOC_CONTENT_COUNT                      ),
MTD(PR_ATTACHMENT_X400_PARAMETERS               ),
MTD(PR_ATTACH_DATA_OBJ                          ),
MTD(PR_ATTACH_DATA_BIN                          ),
MTD(PR_ATTACH_ENCODING                          ),
MTD(PR_ATTACH_EXTENSION                         ),
MTD(PR_ATTACH_EXTENSION_W                       ),
MTD(PR_ATTACH_EXTENSION_A                       ),
MTD(PR_ATTACH_FILENAME                          ),
MTD(PR_ATTACH_FILENAME_W                        ),
MTD(PR_ATTACH_FILENAME_A                        ),
MTD(PR_ATTACH_METHOD                            ),
MTD(PR_ATTACH_LONG_FILENAME                     ),
MTD(PR_ATTACH_LONG_FILENAME_W                   ),
MTD(PR_ATTACH_LONG_FILENAME_A                   ),
MTD(PR_ATTACH_PATHNAME                          ),
MTD(PR_ATTACH_PATHNAME_W                        ),
MTD(PR_ATTACH_PATHNAME_A                        ),
MTD(PR_ATTACH_RENDERING                         ),
MTD(PR_ATTACH_TAG                               ),
MTD(PR_RENDERING_POSITION                       ),
MTD(PR_ATTACH_TRANSPORT_NAME                    ),
MTD(PR_ATTACH_TRANSPORT_NAME_W                  ),
MTD(PR_ATTACH_TRANSPORT_NAME_A                  ),
MTD(PR_ATTACH_LONG_PATHNAME                     ),
MTD(PR_ATTACH_LONG_PATHNAME_W                   ),
MTD(PR_ATTACH_LONG_PATHNAME_A                   ),
MTD(PR_ATTACH_MIME_TAG                          ),
MTD(PR_ATTACH_MIME_TAG_W                        ),
MTD(PR_ATTACH_MIME_TAG_A                        ),
MTD(PR_ATTACH_ADDITIONAL_INFO                   ),
MTD(PR_DISPLAY_TYPE                             ),
MTD(PR_TEMPLATEID                               ),
MTD(PR_PRIMARY_CAPABILITY                       ),
MTD(PR_7BIT_DISPLAY_NAME                        ),
MTD(PR_ACCOUNT                                  ),
MTD(PR_ACCOUNT_W                                ),
MTD(PR_ACCOUNT_A                                ),
MTD(PR_ALTERNATE_RECIPIENT                      ),
MTD(PR_CALLBACK_TELEPHONE_NUMBER                ),
MTD(PR_CALLBACK_TELEPHONE_NUMBER_W              ),
MTD(PR_CALLBACK_TELEPHONE_NUMBER_A              ),
MTD(PR_CONVERSION_PROHIBITED                    ),
MTD(PR_DISCLOSE_RECIPIENTS                      ),
MTD(PR_GENERATION                               ),
MTD(PR_GENERATION_W                             ),
MTD(PR_GENERATION_A                             ),
MTD(PR_GIVEN_NAME                               ),
MTD(PR_GIVEN_NAME_W                             ),
MTD(PR_GIVEN_NAME_A                             ),
MTD(PR_GOVERNMENT_ID_NUMBER                     ),
MTD(PR_GOVERNMENT_ID_NUMBER_W                   ),
MTD(PR_GOVERNMENT_ID_NUMBER_A                   ),
MTD(PR_BUSINESS_TELEPHONE_NUMBER                ),
MTD(PR_BUSINESS_TELEPHONE_NUMBER_W              ),
MTD(PR_BUSINESS_TELEPHONE_NUMBER_A              ),
MTD(PR_HOME_TELEPHONE_NUMBER                    ),
MTD(PR_HOME_TELEPHONE_NUMBER_W                  ),
MTD(PR_HOME_TELEPHONE_NUMBER_A                  ),
MTD(PR_INITIALS                                 ),
MTD(PR_INITIALS_W                               ),
MTD(PR_INITIALS_A                               ),
MTD(PR_KEYWORD                                  ),
MTD(PR_KEYWORD_W                                ),
MTD(PR_KEYWORD_A                                ),
MTD(PR_LANGUAGE                                 ),
MTD(PR_LANGUAGE_W                               ),
MTD(PR_LANGUAGE_A                               ),
MTD(PR_LOCATION                                 ),
MTD(PR_LOCATION_W                               ),
MTD(PR_LOCATION_A                               ),
MTD(PR_MAIL_PERMISSION                          ),
MTD(PR_MHS_COMMON_NAME                          ),
MTD(PR_MHS_COMMON_NAME_W                        ),
MTD(PR_MHS_COMMON_NAME_A                        ),
MTD(PR_ORGANIZATIONAL_ID_NUMBER                 ),
MTD(PR_ORGANIZATIONAL_ID_NUMBER_W               ),
MTD(PR_ORGANIZATIONAL_ID_NUMBER_A               ),
MTD(PR_SURNAME                                  ),
MTD(PR_SURNAME_W                                ),
MTD(PR_SURNAME_A                                ),
MTD(PR_ORIGINAL_ENTRYID                         ),
MTD(PR_ORIGINAL_DISPLAY_NAME                    ),
MTD(PR_ORIGINAL_DISPLAY_NAME_W                  ),
MTD(PR_ORIGINAL_DISPLAY_NAME_A                  ),
MTD(PR_ORIGINAL_SEARCH_KEY                      ),
MTD(PR_POSTAL_ADDRESS                           ),
MTD(PR_POSTAL_ADDRESS_W                         ),
MTD(PR_POSTAL_ADDRESS_A                         ),
MTD(PR_COMPANY_NAME                             ),
MTD(PR_COMPANY_NAME_W                           ),
MTD(PR_COMPANY_NAME_A                           ),
MTD(PR_TITLE                                    ),
MTD(PR_TITLE_W                                  ),
MTD(PR_TITLE_A                                  ),
MTD(PR_DEPARTMENT_NAME                          ),
MTD(PR_DEPARTMENT_NAME_W                        ),
MTD(PR_DEPARTMENT_NAME_A                        ),
MTD(PR_OFFICE_LOCATION                          ),
MTD(PR_OFFICE_LOCATION_W                        ),
MTD(PR_OFFICE_LOCATION_A                        ),
MTD(PR_PRIMARY_TELEPHONE_NUMBER                 ),
MTD(PR_PRIMARY_TELEPHONE_NUMBER_W               ),
MTD(PR_PRIMARY_TELEPHONE_NUMBER_A               ),
MTD(PR_BUSINESS2_TELEPHONE_NUMBER               ),
MTD(PR_BUSINESS2_TELEPHONE_NUMBER_W             ),
MTD(PR_BUSINESS2_TELEPHONE_NUMBER_A             ),
MTD(PR_MOBILE_TELEPHONE_NUMBER                  ),
MTD(PR_MOBILE_TELEPHONE_NUMBER_W                ),
MTD(PR_MOBILE_TELEPHONE_NUMBER_A                ),
MTD(PR_RADIO_TELEPHONE_NUMBER                   ),
MTD(PR_RADIO_TELEPHONE_NUMBER_W                 ),
MTD(PR_RADIO_TELEPHONE_NUMBER_A                 ),
MTD(PR_CAR_TELEPHONE_NUMBER                     ),
MTD(PR_CAR_TELEPHONE_NUMBER_W                   ),
MTD(PR_CAR_TELEPHONE_NUMBER_A                   ),
MTD(PR_OTHER_TELEPHONE_NUMBER                   ),
MTD(PR_OTHER_TELEPHONE_NUMBER_W                 ),
MTD(PR_OTHER_TELEPHONE_NUMBER_A                 ),
MTD(PR_TRANSMITABLE_DISPLAY_NAME                ),
MTD(PR_TRANSMITABLE_DISPLAY_NAME_W              ),
MTD(PR_TRANSMITABLE_DISPLAY_NAME_A              ),
MTD(PR_PAGER_TELEPHONE_NUMBER                   ),
MTD(PR_PAGER_TELEPHONE_NUMBER_W                 ),
MTD(PR_PAGER_TELEPHONE_NUMBER_A                 ),
MTD(PR_USER_CERTIFICATE                         ),
MTD(PR_PRIMARY_FAX_NUMBER                       ),
MTD(PR_PRIMARY_FAX_NUMBER_W                     ),
MTD(PR_PRIMARY_FAX_NUMBER_A                     ),
MTD(PR_BUSINESS_FAX_NUMBER                      ),
MTD(PR_BUSINESS_FAX_NUMBER_W                    ),
MTD(PR_BUSINESS_FAX_NUMBER_A                    ),
MTD(PR_HOME_FAX_NUMBER                          ),
MTD(PR_HOME_FAX_NUMBER_W                        ),
MTD(PR_HOME_FAX_NUMBER_A                        ),
MTD(PR_COUNTRY                                  ),
MTD(PR_COUNTRY_W                                ),
MTD(PR_COUNTRY_A                                ),
MTD(PR_LOCALITY                                 ),
MTD(PR_LOCALITY_W                               ),
MTD(PR_LOCALITY_A                               ),
MTD(PR_STATE_OR_PROVINCE                        ),
MTD(PR_STATE_OR_PROVINCE_W                      ),
MTD(PR_STATE_OR_PROVINCE_A                      ),
MTD(PR_STREET_ADDRESS                           ),
MTD(PR_STREET_ADDRESS_W                         ),
MTD(PR_STREET_ADDRESS_A                         ),
MTD(PR_POSTAL_CODE                              ),
MTD(PR_POSTAL_CODE_W                            ),
MTD(PR_POSTAL_CODE_A                            ),
MTD(PR_POST_OFFICE_BOX                          ),
MTD(PR_POST_OFFICE_BOX_W                        ),
MTD(PR_POST_OFFICE_BOX_A                        ),
MTD(PR_TELEX_NUMBER                             ),
MTD(PR_TELEX_NUMBER_W                           ),
MTD(PR_TELEX_NUMBER_A                           ),
MTD(PR_ISDN_NUMBER                              ),
MTD(PR_ISDN_NUMBER_W                            ),
MTD(PR_ISDN_NUMBER_A                            ),
MTD(PR_ASSISTANT_TELEPHONE_NUMBER               ),
MTD(PR_ASSISTANT_TELEPHONE_NUMBER_W             ),
MTD(PR_ASSISTANT_TELEPHONE_NUMBER_A             ),
MTD(PR_HOME2_TELEPHONE_NUMBER                   ),
MTD(PR_HOME2_TELEPHONE_NUMBER_W                 ),
MTD(PR_HOME2_TELEPHONE_NUMBER_A                 ),
MTD(PR_ASSISTANT                                ),
MTD(PR_ASSISTANT_W                              ),
MTD(PR_ASSISTANT_A                              ),
MTD(PR_SEND_RICH_INFO                           ),
MTD(PR_WEDDING_ANNIVERSARY                      ),
MTD(PR_BIRTHDAY                                 ),
MTD(PR_HOBBIES                                  ),
MTD(PR_HOBBIES_W                                ),
MTD(PR_HOBBIES_A                                ),
MTD(PR_MIDDLE_NAME                              ),
MTD(PR_MIDDLE_NAME_W                            ),
MTD(PR_MIDDLE_NAME_A                            ),
MTD(PR_DISPLAY_NAME_PREFIX                      ),
MTD(PR_DISPLAY_NAME_PREFIX_W                    ),
MTD(PR_DISPLAY_NAME_PREFIX_A                    ),
MTD(PR_PROFESSION                               ),
MTD(PR_PROFESSION_W                             ),
MTD(PR_PROFESSION_A                             ),
MTD(PR_PREFERRED_BY_NAME                        ),
MTD(PR_PREFERRED_BY_NAME_W                      ),
MTD(PR_PREFERRED_BY_NAME_A                      ),
MTD(PR_SPOUSE_NAME                              ),
MTD(PR_SPOUSE_NAME_W                            ),
MTD(PR_SPOUSE_NAME_A                            ),
MTD(PR_COMPUTER_NETWORK_NAME                    ),
MTD(PR_COMPUTER_NETWORK_NAME_W                  ),
MTD(PR_COMPUTER_NETWORK_NAME_A                  ),
MTD(PR_CUSTOMER_ID                              ),
MTD(PR_CUSTOMER_ID_W                            ),
MTD(PR_CUSTOMER_ID_A                            ),
MTD(PR_TTYTDD_PHONE_NUMBER                      ),
MTD(PR_TTYTDD_PHONE_NUMBER_W                    ),
MTD(PR_TTYTDD_PHONE_NUMBER_A                    ),
MTD(PR_FTP_SITE                                 ),
MTD(PR_FTP_SITE_W                               ),
MTD(PR_FTP_SITE_A                               ),
MTD(PR_GENDER                                   ),
MTD(PR_MANAGER_NAME                             ),
MTD(PR_MANAGER_NAME_W                           ),
MTD(PR_MANAGER_NAME_A                           ),
MTD(PR_NICKNAME                                 ),
MTD(PR_NICKNAME_W                               ),
MTD(PR_NICKNAME_A                               ),
MTD(PR_PERSONAL_HOME_PAGE                       ),
MTD(PR_PERSONAL_HOME_PAGE_W                     ),
MTD(PR_PERSONAL_HOME_PAGE_A                     ),
MTD(PR_BUSINESS_HOME_PAGE                       ),
MTD(PR_BUSINESS_HOME_PAGE_W                     ),
MTD(PR_BUSINESS_HOME_PAGE_A                     ),
MTD(PR_CONTACT_VERSION                          ),
MTD(PR_CONTACT_ENTRYIDS                         ),
MTD(PR_CONTACT_ADDRTYPES                        ),
MTD(PR_CONTACT_ADDRTYPES_W                      ),
MTD(PR_CONTACT_ADDRTYPES_A                      ),
MTD(PR_CONTACT_DEFAULT_ADDRESS_INDEX            ),
MTD(PR_CONTACT_EMAIL_ADDRESSES                  ),
MTD(PR_CONTACT_EMAIL_ADDRESSES_W                ),
MTD(PR_CONTACT_EMAIL_ADDRESSES_A                ),
MTD(PR_COMPANY_MAIN_PHONE_NUMBER                ),
MTD(PR_COMPANY_MAIN_PHONE_NUMBER_W              ),
MTD(PR_COMPANY_MAIN_PHONE_NUMBER_A              ),
MTD(PR_CHILDRENS_NAMES                          ),
MTD(PR_CHILDRENS_NAMES_W                        ),
MTD(PR_CHILDRENS_NAMES_A                        ),
MTD(PR_HOME_ADDRESS_CITY                        ),
MTD(PR_HOME_ADDRESS_CITY_W                      ),
MTD(PR_HOME_ADDRESS_CITY_A                      ),
MTD(PR_HOME_ADDRESS_COUNTRY                     ),
MTD(PR_HOME_ADDRESS_COUNTRY_W                   ),
MTD(PR_HOME_ADDRESS_COUNTRY_A                   ),
MTD(PR_HOME_ADDRESS_POSTAL_CODE                 ),
MTD(PR_HOME_ADDRESS_POSTAL_CODE_W               ),
MTD(PR_HOME_ADDRESS_POSTAL_CODE_A               ),
MTD(PR_HOME_ADDRESS_STATE_OR_PROVINCE           ),
MTD(PR_HOME_ADDRESS_STATE_OR_PROVINCE_W         ),
MTD(PR_HOME_ADDRESS_STATE_OR_PROVINCE_A         ),
MTD(PR_HOME_ADDRESS_STREET                      ),
MTD(PR_HOME_ADDRESS_STREET_W                    ),
MTD(PR_HOME_ADDRESS_STREET_A                    ),
MTD(PR_HOME_ADDRESS_POST_OFFICE_BOX             ),
MTD(PR_HOME_ADDRESS_POST_OFFICE_BOX_W           ),
MTD(PR_HOME_ADDRESS_POST_OFFICE_BOX_A           ),
MTD(PR_OTHER_ADDRESS_CITY                       ),
MTD(PR_OTHER_ADDRESS_CITY_W                     ),
MTD(PR_OTHER_ADDRESS_CITY_A                     ),
MTD(PR_OTHER_ADDRESS_COUNTRY                    ),
MTD(PR_OTHER_ADDRESS_COUNTRY_W                  ),
MTD(PR_OTHER_ADDRESS_COUNTRY_A                  ),
MTD(PR_OTHER_ADDRESS_POSTAL_CODE                ),
MTD(PR_OTHER_ADDRESS_POSTAL_CODE_W              ),
MTD(PR_OTHER_ADDRESS_POSTAL_CODE_A              ),
MTD(PR_OTHER_ADDRESS_STATE_OR_PROVINCE          ),
MTD(PR_OTHER_ADDRESS_STATE_OR_PROVINCE_W        ),
MTD(PR_OTHER_ADDRESS_STATE_OR_PROVINCE_A        ),
MTD(PR_OTHER_ADDRESS_STREET                     ),
MTD(PR_OTHER_ADDRESS_STREET_W                   ),
MTD(PR_OTHER_ADDRESS_STREET_A                   ),
MTD(PR_OTHER_ADDRESS_POST_OFFICE_BOX            ),
MTD(PR_OTHER_ADDRESS_POST_OFFICE_BOX_W          ),
MTD(PR_OTHER_ADDRESS_POST_OFFICE_BOX_A          ),
MTD(PR_STORE_PROVIDERS                          ),
MTD(PR_AB_PROVIDERS                             ),
MTD(PR_TRANSPORT_PROVIDERS                      ),
MTD(PR_DEFAULT_PROFILE                          ),
MTD(PR_AB_SEARCH_PATH                           ),
MTD(PR_AB_DEFAULT_DIR                           ),
MTD(PR_AB_DEFAULT_PAB                           ),
MTD(PR_FILTERING_HOOKS                          ),
MTD(PR_SERVICE_NAME                             ),
MTD(PR_SERVICE_NAME_W                           ),
MTD(PR_SERVICE_NAME_A                           ),
MTD(PR_SERVICE_DLL_NAME                         ),
MTD(PR_SERVICE_DLL_NAME_W                       ),
MTD(PR_SERVICE_DLL_NAME_A                       ),
MTD(PR_SERVICE_ENTRY_NAME                       ),
MTD(PR_SERVICE_UID                              ),
MTD(PR_SERVICE_EXTRA_UIDS                       ),
MTD(PR_SERVICES                                 ),
MTD(PR_SERVICE_SUPPORT_FILES                    ),
MTD(PR_SERVICE_SUPPORT_FILES_W                  ),
MTD(PR_SERVICE_SUPPORT_FILES_A                  ),
MTD(PR_SERVICE_DELETE_FILES                     ),
MTD(PR_SERVICE_DELETE_FILES_W                   ),
MTD(PR_SERVICE_DELETE_FILES_A                   ),
MTD(PR_AB_SEARCH_PATH_UPDATE                    ),
MTD(PR_PROFILE_NAME                             ),
MTD(PR_PROFILE_NAME_A                           ),
MTD(PR_PROFILE_NAME_W                           ),
MTD(PR_IDENTITY_DISPLAY                         ),
MTD(PR_IDENTITY_DISPLAY_W                       ),
MTD(PR_IDENTITY_DISPLAY_A                       ),
MTD(PR_IDENTITY_ENTRYID                         ),
MTD(PR_RESOURCE_METHODS                         ),
MTD(PR_RESOURCE_TYPE                            ),
MTD(PR_STATUS_CODE                              ),
MTD(PR_IDENTITY_SEARCH_KEY                      ),
MTD(PR_OWN_STORE_ENTRYID                        ),
MTD(PR_RESOURCE_PATH                            ),
MTD(PR_RESOURCE_PATH_W                          ),
MTD(PR_RESOURCE_PATH_A                          ),
MTD(PR_STATUS_STRING                            ),
MTD(PR_STATUS_STRING_W                          ),
MTD(PR_STATUS_STRING_A                          ),
MTD(PR_X400_DEFERRED_DELIVERY_CANCEL            ),
MTD(PR_HEADER_FOLDER_ENTRYID                    ),
MTD(PR_REMOTE_PROGRESS                          ),
MTD(PR_REMOTE_PROGRESS_TEXT                     ),
MTD(PR_REMOTE_PROGRESS_TEXT_W                   ),
MTD(PR_REMOTE_PROGRESS_TEXT_A                   ),
MTD(PR_REMOTE_VALIDATE_OK                       ),
MTD(PR_CONTROL_FLAGS                            ),
MTD(PR_CONTROL_STRUCTURE                        ),
MTD(PR_CONTROL_TYPE                             ),
MTD(PR_DELTAX                                   ),
MTD(PR_DELTAY                                   ),
MTD(PR_XPOS                                     ),
MTD(PR_YPOS                                     ),
MTD(PR_CONTROL_ID                               ),
MTD(PR_INITIAL_DETAILS_PANE                     ),
{0,0}
};

EXTERN_C LPCSTR WINAPI GetMapiTagDescriptionA( DWORD dwTag )
{
    for( USHORT usIndex = 0; descriptions[usIndex].lpszString; usIndex++ )
    {
        if( descriptions[usIndex].dwTag == dwTag )
        {
            return descriptions[usIndex].lpszString;
        }
    }
    static CHAR szUnknown[60];
    sprintf( szUnknown, "0x%08lx", dwTag );
    return szUnknown;
}

EXTERN_C ULONG WINAPI LookupMapiTagByNameA( LPCSTR lpszTag )
{
    for( USHORT usIndex = 0; descriptions[usIndex].lpszString; usIndex++ )
    {
        if( strcmp( descriptions[usIndex].lpszString, lpszTag ) == 0 )
        {
            return descriptions[usIndex].dwTag;
        }
    }
    return 0;
}
